/* Agent Library Common

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF

*/

#include <stddef.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "agent_lib.h"
#include "actuate.h"

uint8_t act_series[]={                                                          // ACTp^̔z
    0b00101010
   ,0b00000000
   ,0b00110110
   ,0b00000000
   ,0b00010101
   ,0b00000000
};
uint8_t act_id =0;                                                              // ACTp^̃CfbNX
Act act_get;                                                                    // 擾ACT
Frame frame_get;                                                                // 擾t[

Frame* fr_get =NULL;                                                            // t[i|C^j
Frame* fr_transmit =NULL;
extern uint8_t rhythm_source;                                                   // Y\[X

// xNgFXCb`iPB1/PCINT9j
ISR (PCINT1_vect) {
    
    if (BIT_CHECK(PCINT9_PIN, PCINT9_BIT)) {
        return;                                                                 // PCINT9 ͖
    }
    
    switch (rhythm_source) {
    case SWITCH_TRG:
        fr_get = make_frame(get_act(), &frame_get);                             // ACT擾Ct[
        break;
    case TIMER_TRG:
        // WDTG~ȂnCғȂ~
        if (WDTCSR == 0x00) {
            RESET_WDT;                                                          // WDT Zbg    wdt_reset();
            WDTCSR |= _WDT_CHANGE;                                              // WDT ݒύXiFύXO̕K{j
            WDTCSR = _WDT_INTERRUPT | _WDT_500MS;                               // WDT MODE , PRESCALER
        }
        else {
            RESET_WDT;                                                          // WDT Zbg    wdt_reset();
            WDTCSR |= _WDT_CHANGE;                                              // WDT ݒύXiFύXO̕K{j
            WDTCSR = 0x00;                                                      // WDT ~
        }
        break;
    }

}

// xNgFWatch Dog Timer
ISR (WATCHDOG_vect) {
    fr_get = make_frame(get_act(), &frame_get);                                 // ACT擾Ct[
}

// ACT擾
//mߒlnACTp^
Act* get_act(void) {

    act_get.act = act_series[act_id];                                          // ACT擾
    if (++act_id >= sizeof(act_series)) act_id = 0;                             // ACTXVizؑցj
    
    return &act_get;
}

// oCgt[Ɋi[
//mPnfr_target:Ώۂ̃t[mQnadd_byte:oCg
void add_byte_frame(Frame* fr_target, uint8_t add_byte) {
    
    if (fr_target->pos_wr < FRAME_SIZE) {                                       // wrʒut[TCYł΁CсCwrʒuXV
        fr_target->data[fr_target->pos_wr] = add_byte;
        fr_target->pos_wr ++;
        if (fr_target->pos_wr == FRAME_SIZE) {                                  // F傤ǖt
            fr_target->status = FRAME_FULL;
        }
        else {                                                                  // F܂ǉł
            fr_target->status = FRAME_SHORT;
        }
    }
    else {
        fr_target->status = FRAME_OVER;                                         // t[TCY𒴉
    }
    
}

// f[^t[
//mPnACTmQn쐬t[
//mߒln쐬t[
Frame* make_frame(Act* act_target, Frame* fr_target) {
    
    // t[
    fr_target->data[ACT]     =  act_target->act;                                // ACT
    fr_target->data[ACT_REV] = ~act_target->act;                                // `i]R[hj
    
    // dグ
    fr_target->status = FRAME_FULL;                                             // t[i[Xe[^XF傤ǖt
    
    return fr_target;
}

// t[
//mߒlnɖ肪Δ[lԂ
uint8_t accept_frame(Frame* fr_accept) {
    
    fr_transmit = NULL;                                                         // Mt[
    
    if (!check_frame(fr_accept)) {                                              // Mt[̐`FbN
        
        actuate(fr_accept->data[ACT]);
        fr_transmit = fr_accept;                                                // Mt[
        
        return ACCEPT_PASSED;
    }
    else {
        return CHECK_FR_ERROR;                                                  // Mt[s
    }
    
}

// t[`FbN
//mnfr_target:Ώۂ̃t[
//mߒln`FbNɊ|[lԂ
uint8_t check_frame(Frame* fr_target) {
    
    // `FbNFt[\oCg̉ߕs΁C𒆒f
    if (fr_target->status != FRAME_FULL) {
        return SHORT_OR_OVER;
    }
    
    // ``FbNF]R[ȟ؁iXORjFrbgsv̏ꍇC𒆒f
    if ((fr_target->data[ACT] ^ fr_target->data[ACT_REV]) != 0xFF) {
        return BIT_DISCORD;
    }

    return PASSED;
}
