/* Agent: IR Receiver

    ΏۃfoCXF
    EATtiny44A/84A
    EATtiny2313/4313
    EATmega88P/88PA
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    
    lF
    
*/

#include <avr/interrupt.h>

#include "agent_lib.h"                                                          // Agentp
#include "ir_receive.h"

// Oϐ錾
extern volatile Frame* fr_get;
Frame frame_receive_ir;

// ϐ錾
volatile uint8_t ir_receive_bit =BIT_NOP;                                       // IRMrbgʒuFMbyteɂbitʒu\
volatile uint8_t ir_receive_byte =0;                                            // IRMoCg

// xNgFINT0̗FIRR[h̗茟m
ISR (EXT_INT0_vect) {
    uint8_t ircode01;                                                           // Zero/One R[h茋
    
    ircode01 = ircode01_analyze(ir_receive_bit);                                // ͊Jni0/1j
    switch (ircode01) {
    case IRCODE_ZERO:
        // OR[h̏ꍇF
        ir_receive_byte &= ~(1<<ir_receive_bit);                                // Yrbgiir_receive_bitjɂOL^
        ir_receive_bit ++;                                                      // rbgʒuXVFbitʒuw
        break;
    case IRCODE_ONE:
        // PR[h̏ꍇF
        ir_receive_byte |= (1<<ir_receive_bit);                                 // Yrbgiir_receive_bitjɂPL^
        ir_receive_bit ++;                                                      // rbgʒuXVFbitʒuw
        break;
    case IRCODE_ERROR:
        // OPG[FNOP}[NtGNOP}[N STARTR[hMŃZbg
        ir_receive_bit = BIT_NOP;                                               // NOP}[N
        break;
    }
}

// xNgiMR[h́FSTART/STOPjF^C}̔rvA
// START,STOPR[h^C~OɒBƂ̊
ISR (TIM0_COMPA_vect) {
    uint8_t ircodesp;                                                           // START/STOP R[h茋

    ircodesp = ircodesp_analyze(ir_receive_bit);                                // ͊JniSTART/STOPj
    switch (ircodesp) {
    case IRCODE_START:                                                          // t[Jn:
        // MF
        frame_receive_ir.pos_wr = ACT;                                          // Mt[ւ̏ʒu
        frame_receive_ir.status = FRAME_INI;                                    // Mt[̏:i[Xe[^X
        ir_receive_byte = 0x00;                                                 // IRMoCg
        ir_receive_bit = 0;                                                     // rbgʒuOɏ
        break;
    case IRCODE_STOP:                                                           // oCgI[: IRMoCgMt[ɏ
        add_byte_frame(&frame_receive_ir, ir_receive_byte);
        ir_receive_byte = 0x00;                                                 // IRMoCg
        ir_receive_bit = 0;                                                     // rbgʒuOɏ
        break;
    case IRCODE_COMPLETE:                                                       // t[I[:
        fr_get = &frame_receive_ir;                                             // Mt[擾t[Ƃē
        ir_receive_bit = BIT_NOP;                                               // rbgʒuNOPɏ
        break;
    }
}
